function toggleDropdown(ref, filterBtn, dropdownId, datepickerStartId, datepickerEndId, datepickerStart, datepickerEnd) {
    let dateFormat = "dd/mm/yyyy",

        from = $("#"+datepickerStartId)
            .datepicker({
                defaultDate: datepickerStart != null ? new Date(datepickerStart) : null,
                changeMonth: true,
                numberOfMonths: 1,
                dateFormat: dateFormat,
                changeYear: true,
                firstDay: 1,
                maxDate: datepickerEnd != null ? new Date(datepickerEnd) : null

            })
            .on( "change", function() {
                to.datepicker( "option", "minDate", getDate( this ) );
                ref?.invokeMethodAsync('setStartDate', getDate(this))
            }),
        to = $("#"+datepickerEndId).datepicker({
            defaultDate: datepickerEnd != null ? new Date(datepickerEnd) : null,
            changeMonth: true,
            numberOfMonths: 1,
            dateFormat: dateFormat,
            changeYear: true,
            firstDay: 1,
            minDate: datepickerStart != null ? new Date(datepickerStart) : null
        })
            .on( "change", function() {
                from.datepicker( "option", "maxDate", getDate( this ) );
                ref?.invokeMethodAsync('setEndDate', getDate(this))
            });
    function getDate( element ) {
        let date;
        try {
            date = $.datepicker.parseDate( dateFormat, element.value );
        } catch( error ) {
            date = null;
        }

        return date;
    }
    let dropdown = document.getElementById(dropdownId);
    document.getElementById(filterBtn)?.addEventListener("click", function(event){
        if (dropdown?.contains(event.target))
            return
        //refreshDatepicker(datepickerStartId, datepickerEndId, datepickerStart, datepickerEnd)
        if(!dropdown?.classList.contains("visible")) {
            ref?.invokeMethodAsync('clearFilter')
        }
        event.preventDefault();
        event.stopPropagation();
        let dropdowns = document.querySelectorAll(".dropdown-container");
        dropdowns?.forEach(item => {
            if(item.id !== dropdownId) 
                item.classList.remove("visible")
        })
        dropdown?.classList.toggle("visible")
    })
    
    document.body.addEventListener("click", function (event) {
        if(dropdown?.contains(event.target) 
            || event.target.classList.contains("ui-icon-circle-triangle-e") 
            || event.target.classList.contains("ui-icon-circle-triangle-w") 
            || event.target.classList.contains("ui-datepicker-prev") 
            || event.target.classList.contains("ui-datepicker-next"))
            return
        ref?.invokeMethodAsync('clearFilter')
        dropdown?.classList.remove("visible")
    })
}

function hideDropdown(dropdownId){
    document.getElementById(dropdownId).classList.remove("visible")
}


function refreshDatepicker(datepickerStartId, datepickerEndId, datepickerStart, datepickerEnd){
    $("#"+datepickerStartId).datepicker( "option", "maxDate", datepickerEnd != null ? new Date(datepickerEnd) : null);
    $("#"+datepickerEndId).datepicker( "option", "minDate", datepickerStart != null ? new Date(datepickerStart) : null);
    $("#"+datepickerStartId).datepicker('setDate', datepickerStart != null ? new Date(datepickerStart) : null);
    $("#"+datepickerEndId).datepicker('setDate', datepickerEnd != null ? new Date(datepickerEnd) : null);
}
